using System;
using System.Runtime.InteropServices; //For the DllImport of AIOETHW.dll Driver API

namespace AIOETHW
{
	public class AEWNet
	{
		//Prototype AIOETHW.dll Functions:

		[DllImport("AIOETHW.DLL", CharSet = CharSet.Ansi, CallingConvention = CallingConvention.Cdecl)] public static extern UIntPtr AEW_Connect(char[] Host, Int32 Index);
		[DllImport("AIOETHW.DLL", CharSet = CharSet.Ansi, CallingConvention = CallingConvention.Cdecl)] public static extern UInt32 AEW_Disconnect(UIntPtr uClientref);

		[DllImport("AIOETHW.DLL", CharSet = CharSet.Ansi, CallingConvention = CallingConvention.Cdecl)] public static extern UInt32 AEW_SetTimeout(UIntPtr uClientref, Int32 TimeoutMS);
		[DllImport("AIOETHW.DLL", CharSet = CharSet.Ansi, CallingConvention = CallingConvention.Cdecl)] public static extern UInt32 AEW_ChangeDeviceIP(UIntPtr uClientref, char[] NewIP);
		[DllImport("AIOETHW.DLL", CharSet = CharSet.Ansi, CallingConvention = CallingConvention.Cdecl)] public static extern UInt32 AEW_ChangeSubnet(UIntPtr uClientref, char[] NewSubnet);
		[DllImport("AIOETHW.DLL", CharSet = CharSet.Ansi, CallingConvention = CallingConvention.Cdecl)] public static extern UInt32 AEW_ChangeGateway(UIntPtr uClientref, char[] NewGateway);
		[DllImport("AIOETHW.DLL", CharSet = CharSet.Ansi, CallingConvention = CallingConvention.Cdecl)] public static extern UInt32 AEW_ChangeNetworking(UIntPtr uClientref, char[] NewIP, char[] NewSubnet, char[] NewGateway);
		[DllImport("AIOETHW.DLL", CharSet = CharSet.Ansi, CallingConvention = CallingConvention.Cdecl)] public static extern UInt32 AEW_GetStatus(UIntPtr uClientref, ref Int32 pStatusBytes, ref Byte pStatus);
		[DllImport("AIOETHW.DLL", CharSet = CharSet.Ansi, CallingConvention = CallingConvention.Cdecl)] public static extern UInt32 AEW_GetStatusEx(UIntPtr uClientref, UInt32 StatusFormat, ref Int32 pStatusBytes, ref Byte pStatus);

		[DllImport("AIOETHW.DLL", CharSet = CharSet.Ansi, CallingConvention = CallingConvention.Cdecl)] public static extern UInt32 AEW_DEF_Configure(UIntPtr uClientRef, ref Int32 pIOConfigBytes, [In, Out] Byte[] pIOConfig);
        [DllImport("AIOETHW.DLL", CharSet = CharSet.Ansi, CallingConvention = CallingConvention.Cdecl)] public static extern UInt32 AEW_DEF_GetIOConfig(UIntPtr uClientRef, ref Int32 pIOConfigBytes, [In, Out] Byte[] pIOConfig);
        


        [DllImport("AIOETHW.DLL", CharSet = CharSet.Ansi, CallingConvention = CallingConvention.Cdecl)] public static extern UInt32 AEW_DIO_Configure(UIntPtr uClientref, ref Int32 pDataBytes, [In, Out] Byte[] pData, ref UInt16 pDirection);
		[DllImport("AIOETHW.DLL", CharSet = CharSet.Ansi, CallingConvention = CallingConvention.Cdecl)] public static extern UInt32 AEW_DIO_WriteAll(UIntPtr uClientref, ref Int32 pDataBytes, [In, Out] Byte[] pData);
		[DllImport("AIOETHW.DLL", CharSet = CharSet.Ansi, CallingConvention = CallingConvention.Cdecl)] public static extern UInt32 AEW_DIO_Write1(UIntPtr uClientref, Int32 BitIndex, Byte bNewValue);
		[DllImport("AIOETHW.DLL", CharSet = CharSet.Ansi, CallingConvention = CallingConvention.Cdecl)] public static extern UInt32 AEW_DIO_ReadAll(UIntPtr uClientref, ref Int32 pDataBytes, [In, Out] Byte[] pData);

		[DllImport("AIOETHW.DLL", CharSet = CharSet.Ansi, CallingConvention = CallingConvention.Cdecl)] public static extern Int32 AEW_LogEnable();

		[DllImport("AIOETHW.DLL", CharSet = CharSet.Ansi, CallingConvention = CallingConvention.Cdecl)] public static extern UInt32 AEW_DetectDeviceIPs(UInt32 Flags, double Milliseconds, [Out] char[] IntoBuf, UInt32 BufSize, ref UInt32 NeededBufSize);

		[DllImport("AIOETHW.DLL", CharSet = CharSet.Ansi, CallingConvention = CallingConvention.Cdecl)] public static extern UInt32 AEW_DEB_StrToStr(UIntPtr uClientref, ref Int32 pSendPacketBytes, ref Byte pSendPacket, ref Int32 pReplyPacketBytes, ref Byte pReplyPacket);
	}
}
